<template>
    <div class="accordion-item">
        <div :class="{'active': visible}"
             class="accordion-header"
             @click="open">

            <slot name="header"></slot>
            <font-awesome-icon v-if="!visible" icon="plus"/>
            <font-awesome-icon v-if="visible" icon="minus"/>
        </div>

        <transition
            name="accordion"
            @enter="start"
            @after-enter="end"
            @before-leave="start"
            @after-leave="end">

            <div v-show="visible" class="accordion-content">
                <slot name="content"></slot>
            </div>
        </transition>
    </div>
</template>


<script>
export default {
    props: {},
    inject: ["Accordion"],
    data() {
        return {
            index: null
        };
    },
    computed: {
        visible() {
            return this.index == this.Accordion.active;
        }
    },
    methods: {
        open() {
            if (this.visible) {
                this.Accordion.active = null;
            } else {
                this.Accordion.active = this.index;
            }
        },
        start(el) {
            el.style.height = el.scrollHeight + "px";
        },
        end(el) {
            el.style.height = "";
        }
    },
    created() {
        this.Accordion.active = 0;
        this.index = this.Accordion.count++;
    }
};
</script>

<style lang="scss">
@import "../../assets/styles/base/_accordion";
</style>
